<!DOCTYPE html>
<html>

<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Course 365 - Learning with unlimited!</title>

  <!-- Nhúng các thư viện BS4 & jQuery, awesome font -->
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.2.1/css/all.min.css">

  <!-- Các file css và js tự định nghĩa thêm -->
  <script src="https://cdn.datatables.net/1.10.25/css/dataTables.bootstrap4.min.css"></script>
  <script src="https://cdn.datatables.net/1.10.25/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.25/js/dataTables.bootstrap4.min.js"></script>
  <link rel="stylesheet" href="style.css">
  <script src="script.js"></script>
</head>

<body>
  <div class="container">
    <h2 class="text-success" style="text-align: center;">Danh sách Khóa học</h2>
    <p class="text-center text-info">Test Branch 1</p>
    <div class="form-group">
      <button class="btn btn-success" id="btn-add-course"><i class="fa fa-plus"></i>&nbsp; Thêm khóa học</button>
    </div>
    <table id="user-table" class="table table-bordered table-striped table-hover">
      <thead>
        <tr>
          <th>Id</th>
          <th>Mã Khóa học</th>
          <th>Tên Khóa học</th>
          <th>Học phí</th>
          <th>Học phí giảm giá</th>
          <th>Thời lượng</th>
          <th>Trình độ</th>
          <th>Giáo viên</th>
          <th>Action</th>
        </tr>
      </thead>
    </table>

    <!-- Vùng Modal -->

    <!-- Create Course modal -->
    <div>
      <div id="create-course-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="h5-modal-title">Create new Course</h5>
              <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
              <form>
                <div class="row form-group">
                  <label class="col-sm-4">Mã khóa học</label>
                  <input class="col-sm-8 form-control" type="text" id="inp-create-courseCode">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Tên khóa học</label>
                  <input class="col-sm-8 form-control" type="text" id="inp-create-courseName">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Học phí</label>
                  <input class="col-sm-8 form-control" type="number" id="inp-create-price">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Học phí giảm giá</label>
                  <input class="col-sm-8 form-control" type="number" id="inp-create-discountPrice">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Thời lượng</label>
                  <input class="col-sm-8 form-control" type="text" id="inp-create-duration">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Trình độ</label>
                  <input class="col-sm-8 form-control" type="text" id="inp-create-level">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Ảnh khóa học</label>
                  <input class="col-sm-8 form-control" type="text" id="inp-create-coverImage">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Tên giáo viên</label>
                  <input class="col-sm-8 form-control" type="text" id="inp-create-teacherName">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Ảnh giáo viên</label>
                  <input class="col-sm-8 form-control" type="text" id="inp-create-teacherPhoto">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Popular</label>
                  <input class="col-sm-8 form-check-input" type="checkbox" id="inp-create-isPopular">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Trending</label>
                  <input class="col-sm-8 form-check-input" type="checkbox" id="inp-create-isTrending">
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
              <button class="btn btn-primary" id="btn-create-user">Create Voucher</button>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- Update Course modal -->
    <div>
      <div id="update-course-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="h5-modal-title">Update a Course</h5>
              <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
              <form>
                <div class="row form-group">
                  <label class="col-sm-4">Mã khóa học</label>
                  <input class="col-sm-8 form-control" type="text" id="inp-update-courseCode">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Tên khóa học</label>
                  <input class="col-sm-8 form-control" type="text" id="inp-update-courseName">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Học phí</label>
                  <input class="col-sm-8 form-control" type="number" id="inp-update-price">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Học phí giảm giá</label>
                  <input class="col-sm-8 form-control" type="number" id="inp-update-discountPrice">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Thời lượng</label>
                  <input class="col-sm-8 form-control" type="text" id="inp-update-duration">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Trình độ</label>
                  <input class="col-sm-8 form-control" type="text" id="inp-update-level">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Ảnh khóa học</label>
                  <input class="col-sm-8 form-control" type="text" id="inp-update-coverImage">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Tên giáo viên</label>
                  <input class="col-sm-8 form-control" type="text" id="inp-update-teacherName">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Ảnh giáo viên</label>
                  <input class="col-sm-8 form-control" type="text" id="inp-update-teacherPhoto">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Popular</label>
                  <input class="col-sm-8 form-check-input" type="checkbox" id="inp-update-isPopular">
                </div>
                <div class="row form-group">
                  <label class="col-sm-4">Trending</label>
                  <input class="col-sm-8 form-check-input" type="checkbox" id="inp-update-isTrending">
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Cancel</button>
              <button class="btn btn-primary" id="btn-update-user">Update Voucher</button>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- Delete confirm modal -->
    <div>
      <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="h5-modal-title">Course Delete Confirmation</h5>
              <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
              <label>Bạn có chắc chắn muốn xóa Khóa học này không?</label>
            </div>
            <div class="modal-footer">
              <button class="btn btn-danger" id="btn-confirm-delete">Confirm</button>
              <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</body>
<!-- <script src="script.js"></script> -->
<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  const gREQUEST_STATUS_OK = 200;
  const gREQUEST_CREATE_OK = 201; // status 201 là tạo mới thành công
  const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

  var gBASE_URL = "https://624abe0dfd7e30c51c110ac6.mockapi.io/api/v1";

  var gCoursesDB = [];

  var vCourseObjRequest = {
    courseCode: "",
    courseName: "",
    price: 0,
    discountPrice: 0,
    duration: "",
    level: "",
    coverImage: "",
    teacherName: "",
    teacherPhoto: "",
    isPopular: false,
    isTrending: false
  };

  var gUserId;
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  $(document).ready(function () {
    //gui APi lay danh sach khoa hoc
    sendApiGetListCourse();
    //add data list to table
    showListCourse();
    //click btn add new course
    onClickBtnAddNewCourse();
    //on click confirm create btn
    onClickBtnConfirmCreate();
    //click btn edit course
    onClickBtnEditCourse();
    //click btn confirm update
    onClickBtnConfirmUpdate();
    //click btn delete course
    onClickBtnDeleteCourse();
    //click btn confirm delete
    onClickBtnConfirmDelete();
  })
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  //btn click add new course
  function onClickBtnAddNewCourse() {
    $("#btn-add-course").on("click", function () {
      $("#create-course-modal").modal("show");
    })
  }
  //on click btn confirm create
  function onClickBtnConfirmCreate() {
    $("#btn-create-user").on("click", function () {
      addDataToObj(vCourseObjRequest);
      //kiem tra du lieu
      if (checkData(vCourseObjRequest)) {
        //gui Api them khoa hoc
        console.log(vCourseObjRequest);
        //gui Api create course
        sendApiCreateCourse(vCourseObjRequest);
      }
    })
  }
  //btn click edit course
  function onClickBtnEditCourse() {
    $("#user-table").on("click", ".btn-edit", function () {
      var vObjUpdate = editCourse(this);
      //show modal update
      $("#update-course-modal").modal("show");
      //them du lieu vao form update
      addDataToFormUpdate(vObjUpdate);
    })
  }
  //btn click confirm update
  function onClickBtnConfirmUpdate() {
    $("#btn-update-user").on("click", function () {
      addDataToUserObj(vCourseObjRequest);
      if (checkData(vCourseObjRequest)) {
        //gui Api them khoa hoc
        console.log(vCourseObjRequest);
        sendApiUpdateCourse(vCourseObjRequest, gUserId)
      }
    })
  }
  //btn click delete course
  function onClickBtnDeleteCourse() {
    $("#user-table").on("click", ".btn-delete", function () {
      deleteCourse(this);
      $("#delete-confirm-modal").modal("show");
    })
  }
  //btn click confirm delete course
  function onClickBtnConfirmDelete() {
    $("#btn-confirm-delete").on("click", function () {
      // alert(gUserId);
      sendApiDeleteCourse(gUserId)
    })
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  //gui Api lay danh sach khoa hoc
  function sendApiGetListCourse() {
    $.ajax({
      url: gBASE_URL + "/courses",
      type: 'GET',
      dataType: 'json',								// kiểu dữ liệu (thường dùng khi muốn nhận dữ liệu từ server)
      async: false,									//không có thì mặc định là true 
      success: function (res) {
        gCoursesDB = res;						// dữ liệu đã được xử lý sang array     
      },
      error: function (ajaxContext) {
        alert(ajaxContext.responseText)
      }
    });
  }
  //gui Api them khoa hoc
  function sendApiCreateCourse(vObject) {
    $.ajax({
      url: gBASE_URL + "/courses",
      type: 'POST',
      contentType: 'application/json',
      data: JSON.stringify(vObject),
      success: function (res) {
        alert("Them khoa hoc thanh cong.");
        console.log(res);
        showFrontEndAfterCreate();
      },
      error: function (ajaxContext) {
        alert(ajaxContext.responseText)
      }
    });
  }
  //gui Api update khoa hoc
  function sendApiUpdateCourse(vObject, vUserId) {
    $.ajax({
      url: gBASE_URL + "/courses/" + vUserId,
      type: 'PUT',
      contentType: 'application/json',
      data: JSON.stringify(vObject),
      success: function (res) {
        alert("Sua khoa hoc thanh cong.");
        console.log(res);
        showFrontEndAfterUpdate();
      },
      error: function (ajaxContext) {
        alert(ajaxContext.responseText)
      }
    });
  }
  //gui Api xoa khoa hoc
  function sendApiDeleteCourse(vUserId) {
    $.ajax({
      url: gBASE_URL + "/courses/" + vUserId,
      type: 'DELETE',
      contentType: 'application/json',
      success: function (res) {
        alert("Xoa khoa hoc thanh cong.");
        console.log(res);
        showFrontEndAfterDelete();
      },
      error: function (ajaxContext) {
        alert(ajaxContext.responseText)
      }
    });
  }
  //thêm khóa học vào table
  function showListCourse() {
    $("#user-table").DataTable().destroy();
    $("#user-table").DataTable({
      columns: [
        { data: "id" },
        { data: "courseCode" },
        { data: "courseName" },
        { data: "price" },
        { data: "discountPrice" },
        { data: "duration" },
        { data: "level" },
        { data: "teacherName" },
        { data: "action" },
      ],
      columnDefs: [
        {
          targets: 8,
          className: "text-center",
          defaultContent: `
            <i class="fa-solid fa-pen-to-square btn btn-edit" data-toggle="tooltip" data-placement="top" title="Edit"></i>
            <i class="fa-solid fa-trash btn btn-delete" data-toggle="tooltip" data-placement="top" title="Remove"></i>
                `
        }
      ],
    })
    //add data
    addDataToTable(gCoursesDB);
  }
  //add data to table
  function addDataToTable(paramObj) {
    var vTable = $("#user-table").DataTable();
    vTable.clear();
    vTable.rows.add(paramObj);
    vTable.draw();
  }
  //edit course
  function editCourse(params) {
    var vRow = $(params).parents("tr");
    var vTable = $("#user-table").DataTable();
    var vDataRow = vTable.row(vRow).data();
    gUserId = vDataRow.id;
    return vDataRow;
  }
  //delete course
  function deleteCourse(params) {
    var vRow = $(params).parents("tr");
    var vTable = $("#user-table").DataTable();
    var vDataRow = vTable.row(vRow).data();
    gUserId = vDataRow.id;
    return vDataRow;
  }
  //get data on form and add to Obj
  function addDataToObj(paramObj) {
    paramObj.courseCode = $("#inp-create-courseCode").val()
    paramObj.courseName = $("#inp-create-courseName").val()
    paramObj.price = $("#inp-create-price").val()
    paramObj.discountPrice = $("#inp-create-discountPrice").val()
    paramObj.duration = $("#inp-create-duration").val()
    paramObj.level = $("#inp-create-level").val()
    paramObj.coverImage = $("#inp-create-coverImage").val()
    paramObj.teacherName = $("#inp-create-teacherName").val()
    paramObj.teacherPhoto = $("#inp-create-teacherPhoto").val()
    paramObj.teacherName = $("#inp-create-teacherName").val()
    paramObj.isPopular = $("#inp-create-isPopular").prop("checked")
    paramObj.isTrending = $("#inp-create-isTrending").prop("checked")
  }
  //check data Obj form
  function checkData(paramObj) {
    if (paramObj.courseCode == "") {
      alert("Ma khoa hoc khong duoc de trong");
      return false;
    }

    if (paramObj.courseName == "") {
      alert("Ten khoa hoc khong duoc de trong");
      return false;
    }

    if (paramObj.price == "") {
      alert("Hoc phi khong duoc de trong");
      return false;
    }

    if (paramObj.price < 0) {
      alert("Hoc phi khong dung");
      return false;
    }

    if (parseInt(paramObj.discountPrice) > parseInt(paramObj.price) || parseInt(paramObj.discountPrice) < 0) {
      alert("Hoc phi giam gia khong dung.");
      return false;
    }

    if (paramObj.duration == "") {
      alert("Thoi luong khong duoc de trong");
      return false;
    }

    if (paramObj.level == "") {
      alert("Trinh do khong duoc de trong");
      return false;
    }

    if (paramObj.coverImage == "") {
      alert("Anh khoa hoc khong duoc de trong");
      return false;
    }

    if (paramObj.teacherName == "") {
      alert("Ten giao vien khong duoc de trong");
      return false;
    }

    if (paramObj.teacherPhoto == "") {
      alert("Anh giao vien khong duoc de trong");
      return false;
    }

    return true;
  }
  //add data to form edit
  function addDataToFormUpdate(paramObj) {
    $("#inp-update-courseCode").val(paramObj.courseCode);
    $("#inp-update-courseName").val(paramObj.courseName);
    $("#inp-update-price").val(paramObj.price);
    $("#inp-update-discountPrice").val(paramObj.discountPrice);
    $("#inp-update-duration").val(paramObj.duration);
    $("#inp-update-level").val(paramObj.level);
    $("#inp-update-coverImage").val(paramObj.coverImage);
    $("#inp-update-teacherName").val(paramObj.teacherName);
    $("#inp-update-teacherPhoto").val(paramObj.teacherPhoto);
    $("#inp-update-teacherName").val(paramObj.teacherName);
    $("#inp-update-isPopular").attr("checked", paramObj.isPopular);
    $("#inp-update-isTrending").attr("checked", paramObj.isTrending);
  }
  //add data to userObj
  function addDataToUserObj(paramObj) {
    paramObj.courseCode = $("#inp-update-courseCode").val();
    paramObj.courseName = $("#inp-update-courseName").val();
    paramObj.price = $("#inp-update-price").val();
    paramObj.discountPrice = $("#inp-update-discountPrice").val();
    paramObj.duration = $("#inp-update-duration").val();
    paramObj.level = $("#inp-update-level").val();
    paramObj.coverImage = $("#inp-update-coverImage").val();
    paramObj.teacherName = $("#inp-update-teacherName").val();
    paramObj.teacherPhoto = $("#inp-update-teacherPhoto").val();
    paramObj.teacherName = $("#inp-update-teacherName").val();
    paramObj.isPopular = $("#inp-update-isPopular").prop("checked");
    paramObj.isTrending = $("#inp-update-isTrending").prop("checked");
  }
  //xu ly frontend sau khi create
  function showFrontEndAfterCreate() {
    $("#create-course-modal").modal("hide");
    //gui APi lay danh sach khoa hoc
    sendApiGetListCourse();
    //add data list to table
    showListCourse();
  }
  //xu ly frontend sau khi update
  function showFrontEndAfterUpdate() {
    $("#update-course-modal").modal("hide");
    //gui APi lay danh sach khoa hoc
    sendApiGetListCourse();
    //add data list to table
    showListCourse();
  }
  //xu ly frontend sau khi delete
  function showFrontEndAfterDelete() {
    $("#delete-confirm-modal").modal("hide");
    //gui APi lay danh sach khoa hoc
    sendApiGetListCourse();
    //add data list to table
    showListCourse();
  }
</script>

</html>